Bug 1659556 - Review Request: cockpit-composer - Composer GUI for use with Cockpit
Summary: Review Request: cockpit-composer - Composer GUI for use with Cockpit
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Robert-André Mauchin
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-12-14 16:41 UTC by Anthony McInerney
Modified: 2019-03-20 15:41 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-03-20 15:41:14 UTC
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Anthony McInerney 2018-12-14 16:41:16 UTC
Spec URL: https://copr-be.cloud.fedoraproject.org/results/@weldr/welder-web/epel-7-x86_64/00837329-cockpit-composer/cockpit-composer.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/@weldr/welder-web/epel-7-x86_64/00837329-cockpit-composer/cockpit-composer-0.1.7-2.el7.src.rpm
Description: Composer GUI for Cockpit and lorax-composer
Fedora Account System Username: bofh80

This is my first package, seeking a sponsor.

Comment 1 Miro Hrončok 2018-12-14 23:47:24 UTC
Where is the source tarball coming from?

Comment 2 Martin Pitt 2018-12-15 07:51:48 UTC
Coming from here: https://github.com/weldr/welder-web/releases

Comment 3 Miro Hrončok 2018-12-15 09:27:03 UTC
In that case, use:

    Source0:        https://github.com/weldr/welder-web/releases/download/%{version}/cockpit-composer-%{version}.tar.gz


Also, it looks like the repository contains sources an the archive is all prebuilt. This should not be done in Fedora. We should build stuff at %build.

Comment 4 Martin Pitt 2019-01-07 07:52:07 UTC
Right, the upstream releases contain pre-built webpacks in dist/. There really is no realistic way to build them as part of a Fedora package build, as it requires internet access (npm install), or shipping hundreds of megabytes of npm modules which are required for building (webpack, babel, eslint, less compiler, etc.). This would only aggravate the problem -- these npm modules themselves are prebuilt (and thus would recursively require an even larger amount of sources, eventually you reach the entirety of the JavaScript world's source), copyright  review for these would not be humanly possible (while it's autogenerated for the sources that *do* get shipped).

I'm fully aware that this isn't how less insane projects (like C, Python, etc.) get delivered in distributions, but with JavaScript applications there's no other way unfortunately. cockpit, cockpit-ostree, XStatic-Patternfly, etc. do the same thing.

We'll get the Source0 fixed, thanks for pointing out!

Comment 5 Miro Hrončok 2019-01-07 11:03:45 UTC
I understand that, I'm just pointing out the obvious: This should not be done in Fedora. (Note "should",  not "must".)

Comment 6 Robert-André Mauchin 2019-02-08 15:27:47 UTC
 - You need to add a comment detailing how to generate the archive

 - You need to validate the metainfo data: https://docs.fedoraproject.org/en-US/packaging-guidelines/AppData/#_app_data_validate_usage

 - add a %changelog section

Comment 7 Martin Pitt 2019-02-11 16:49:56 UTC
>  - You need to add a comment detailing how to generate the archive

Is "archive" the upstream tarball? These get published on GitHub with some upstream machinery, but usually downstream we don't document how upstream does releases.
What do you mean by this?

> - You need to validate the metainfo data: https://docs.fedoraproject.org/en-US/packaging-guidelines/AppData/#_app_data_validate_usage
> - add a %changelog section

Good points, thank you! Fixed in https://github.com/weldr/welder-web/pull/534 and I'll do a new release later today, and will provide new COPR links.

Comment 9 Martin Pitt 2019-03-06 10:33:12 UTC
For the record, all issues found above have been fixed for a month. What is the next step here?

Comment 10 Miro Hrončok 2019-03-06 10:46:00 UTC
Getting somebody to review this.

(I for example decided not to do so due to the way everything is prebuilt - I don't have time to dedicate to review the process how the tarball is created.)

Comment 11 Martin Pitt 2019-03-06 10:54:45 UTC
The tarball gets created here, in "make dist-gzip": <https://github.com/weldr/welder-web/blob/master/Makefile#L42>

Essentially, it calls webpack to produce dist/ from  src/, and then puts the original source and the webpacks into the release tarball. These get published to <https://github.com/weldr/welder-web/releases>.

Comment 12 Robert-André Mauchin 2019-03-06 14:31:16 UTC
 - Checked the Licenses, all bundled libraries ard CC are MIT licensed.

 - Use "cp -a" or "install -p" to keep file timestamps

 - Don't mix tabs and spaces: tabs on line 2 and 3 but not afterwards



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: Avoid bundling fonts in non-fonts packages.
     Note: Package contains font files
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[!]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: cockpit-composer-0.1.8-2.fc31.noarch.rpm
          cockpit-composer-0.1.8-2.fc31.src.rpm
cockpit-composer.noarch: W: spelling-error %description -l en_US lorax -> borax, Lora
cockpit-composer.src: W: spelling-error %description -l en_US lorax -> borax, Lora
cockpit-composer.src:4: W: mixed-use-of-spaces-and-tabs (spaces: line 4, tab: line 2)
2 packages and 0 specfiles checked; 0 errors, 3 warnings.

Comment 13 Martin Pitt 2019-03-07 08:23:18 UTC
Thanks Robert for the detailled review!

> - Use "cp -a" or "install -p" to keep file timestamps

Done in https://github.com/weldr/welder-web/pull/587

> - Don't mix tabs and spaces: tabs on line 2 and 3 but not afterwards

This needs to be fixed in our release machinery: https://github.com/cockpit-project/cockpituous/pull/245

We'll make a new release soon after this lands.

Comment 14 Robert-André Mauchin 2019-03-07 11:41:35 UTC
(In reply to Martin Pitt from comment #13)
> Thanks Robert for the detailled review!
> 
> > - Use "cp -a" or "install -p" to keep file timestamps
> 
> Done in https://github.com/weldr/welder-web/pull/587
> 
You removed the recursive flag in that commit, are you sure it will work anyway?

Comment 15 Martin Pitt 2019-03-07 11:49:13 UTC
@Robert: Yes, `-a` implies `-R`. Also this went through CI, which tests the installed rpm, so if it would not copy something important, everything would fail.

Comment 16 Robert-André Mauchin 2019-03-07 11:57:30 UTC
Ok, package approved then.

Comment 17 Robert-André Mauchin 2019-03-07 11:57:52 UTC
You still need a sponsor.

Comment 18 Miroslav Suchý 2019-03-08 10:54:05 UTC
I can sponsor Anthony. Anthony, I will contact you via email with more details.

Robert - thank you for the review, it made things easier to me.

Comment 19 Miroslav Suchý 2019-03-08 11:23:57 UTC
the %description can be more descriptive. E.g., the first paragraph from README is just fine. And it should end with a dot (you are missing it there).
https://docs.fedoraproject.org/en-US/packaging-guidelines/#_summary_and_description

Comment 20 Martin Pitt 2019-03-08 14:51:07 UTC
@Miroslav: Fixed the description in https://github.com/weldr/welder-web/pull/588 , thanks for pointing out!

Anthony, Miroslav: We need the "cockpit" Fedora user to be able to push to this dist-git, and preferably also me (martinpitt) as a co-maintainer. But I suppose that happens at "fedpkg request-repo" time?

Comment 21 Miroslav Suchý 2019-03-08 15:54:48 UTC
> But I suppose that happens at "fedpkg request-repo" time?

Yes, or any time later he can go to 
  src.fedoraproject.org/rpms/cockpit-composer
click on the settings tab and add anyone as co-maintainer.

Comment 22 Miroslav Suchý 2019-03-11 12:56:23 UTC
I sponsored Anthony into a packager group. You can now request dist-git branches and proceed with the process.

Comment 23 Anthony McInerney 2019-03-11 15:49:59 UTC
https://pagure.io/releng/fedora-scm-requests/issue/10279#comment-559461

The review is not approved by the assignee of the Bugzilla bug

 
Metadata Update from @limb:
- Issue close_status updated to: Invalid
- Issue status updated to: Closed (was: Open)

2 hours ago
 bofh80 commented an hour ago
Status: NEW → POST
Assignee: nobody@fedoraproject.orgzebob.m@gmail.com
Flags: fedora-review+

It was assigned to zebob.m to approve the package.
It was then assigned to miroslav to approve me the packager.

What's best here. to reassign to zebob.m?

Comment 24 Miro Hrončok 2019-03-11 15:55:06 UTC
Yes.

Comment 25 Gwyn Ciesla 2019-03-11 16:17:03 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/cockpit-composer

Comment 26 Anthony McInerney 2019-03-11 16:22:42 UTC
I've added martinpitt as admin and cockpit as commit access.

Is the package going to be pushed automagically, or do i grab the srpm and commit it?

Comment 27 Martin Pitt 2019-03-11 16:36:36 UTC
Anthony, the first push needs to happen manually. From then on, the cockpituous bot will do releases automatically.

Thanks!

Comment 28 Martin Pitt 2019-03-20 15:41:14 UTC
The initial commit, build, and rawhide upload is done, thanks Anthony! I'll configure our release bots to automatically update Rawhide for new upstream releases: https://github.com/weldr/welder-web/pull/599

I requested an F30 branch here: https://pagure.io/releng/fedora-scm-requests/issue/10594

So this ticket is done now. Thanks Anthony!


Note You need to log in before you can comment on or make changes to this bug.